<div class="dashboard-page flex flex-col flex-auto min-w-0">
    <fuse-alert
    [appearance]="'fill'"
    [dismissible]="true"
    [dismissed]="false"
    [name]="'successerror'"
    [type]="'success'">
    {{Message}} Successfully
</fuse-alert>
    <div class="flex justify-between">
        <div class="text-2xl font-cairo font-bold tracking-tight leading-8 mb-8">Cost Factors</div>
        <button class="sm:inline-flex ml-auto" mat-stroked-button [color]="'primary'" (click)="openDialog()">
            <span class="mx-8">Create Cost Factor</span>
        </button>
    </div>
    <div class="relative">
        <!--table component-->
        <div class="srm-bg mb-4 rounded-lg rounded-t-none">
            <div class="p-6">

                <div class="flex flex-col flex-wrap sm:flex-row items-center max-w-xs sm:max-w-none">
                    <div class="mr-4">
                        <mat-form-field class="fuse-mat-no-subscript fuse-mat-emphasized-affix sm:w-80 mt-4 sm:mt-0 mr-1 mb-3" [floatLabel]="'always'">
                            <div class="text-secondary px-4" matPrefix>Cost Factor</div>
                            <input matInput placeholder="Search by Cost Factor" #input [(ngModel)]="costFactorSearchModel.cfName">
                        </mat-form-field>
                        <mat-form-field class="fuse-mat-no-subscript fuse-mat-emphasized-affix sm:w-80 mt-4 sm:mt-0 mr-1 mb-3" [floatLabel]="'always'">
                            <div class="text-secondary px-4" matPrefix>Description</div>
                            <input matInput placeholder="Search by Description" #input [(ngModel)]="costFactorSearchModel.cfDescription">
                        </mat-form-field>
                        <mat-form-field class="fuse-mat-no-subscript sm:w-32 mt-4 sm:mt-0 mr-1 mb-3" [floatLabel]="'always'">
                            <mat-select [(ngModel)]="costFactorSearchModel.cfTypeId">
                                <mat-option *ngFor="let cfType of costFactorSearchModel.cfTypes" [value]="cfType.id">
                                    {{cfType.text}}
                                </mat-option>
                            </mat-select>
                        </mat-form-field>

                    </div>

                    <button class="sm:inline-flex mb-3" mat-stroked-button [color]="'primary'" type="button" (click)="FetchBasicData()">
                        <mat-icon matPrefix class="icon-size-5 ml-8" [svgIcon]="'heroicons_solid:search'"></mat-icon>
                        <span class="mr-8 ml-4">Search</span>
                    </button>
                </div>

            </div>

        </div>
        <!--base table component-->
        <div class="overflow-auto bg-gray-50 rounded-lg">
            <table mat-table [dataSource]="costFactorSearchModel.costFactorTextViewModels" matSort (matSortChange)="sortData($event)" class="expanded-rows-table font-helvetica text-gray-500">

                <!-- ID Column -->
                <ng-container matColumnDef="id">
                    <th mat-header-cell *matHeaderCellDef style="max-width: 60px; min-width: 50px"></th>
                    <td mat-cell *matCellDef="let row">
                        <button mat-icon-button [matMenuTriggerFor]="options" aria-label="Choose columns">
                            <mat-icon color="primary" class="icon-size-5" svgIcon="heroicons_outline:dots-vertical"></mat-icon>
                        </button>
                        <mat-menu #options="matMenu" class="min-width-235 z-1">
                            <button mat-menu-item type="button" (click)="EditCF(row) ">
                                <mat-icon color="primary" class="icon-size-5" svgIcon="heroicons_outline:pencil"></mat-icon>
                                Edit
                            </button>
                            <button mat-menu-item (click)="DeleteCF(row)">
                                <mat-icon color="primary" class="icon-size-5" svgIcon="heroicons_outline:trash"></mat-icon>
                                Delete
                            </button>
                        </mat-menu>
                    </td>
                </ng-container>

                <!-- Cost Factor -->
                <ng-container matColumnDef="factor">
                    <th mat-header-cell *matHeaderCellDef mat-sort-header style="max-width: 120px; min-width: 110px">
                        Cost Factor
                    </th>
                    <td mat-cell *matCellDef="let row"> {{row.cfName}} </td>
                </ng-container>

                <!-- Description Column -->
                <ng-container matColumnDef="description">
                    <th mat-header-cell *matHeaderCellDef mat-sort-header style="min-width: 140px">
                        Description
                    </th>
                    <td mat-cell *matCellDef="let row"> {{row.cfDescription}} </td>
                </ng-container>

                <!-- Cost Type Column -->
                <ng-container matColumnDef="costType">
                    <th mat-header-cell *matHeaderCellDef mat-sort-header style="max-width: 160px; min-width: 150px">
                        Cost Type
                    </th>
                    <td mat-cell *matCellDef="let row">
                        {{row.cfTypeName}}
                    </td>
                </ng-container>



                <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>

                <!-- Row shown when there is no matching data. -->
                <tr class="mat-row" *matNoDataRow>
                    <td class="mat-cell" colspan="4">No data matching the filter "{{input.value}}"</td>
                </tr>
            </table>
        </div>
        <div class="flex justify-end">
            <mat-paginator class="flex text-base" [pageSizeOptions]="[10, 25, 100]"></mat-paginator>
        </div>
        <!--table component end-->
    </div>
    <div class="flex justify-end ml-auto p-6">
        <button class="sm:inline-flex mr-4" mat-button [color]="'primary'">
            <span class="mx-8">Cancel</span>
        </button>
        <button class="sm:inline-flex" mat-raised-button [color]="'primary'">
            <span class="mx-8">Save Changes</span>
        </button>
    </div>
</div>
